<template>
  <div>
    <div class="text-right mb-3">
      <button class="btn btn-success mr-3" @click.prevent="load">
        Load Response
      </button>
    </div>
    <div class="table-responsive">
      <table
        class="table table-head-custom table-vertical-center table-head-bg table-borderless"
      >
        <thead>
          <tr>
            <th style="min-width: 100px;">Kategori Scope</th>
            <th style="min-width: 100px;">Tanggal Response</th>
            <th style="min-width: 100px;">Status</th>
            <th style="min-width: 100px;">Aksi</th>
          </tr>
        </thead>
        <template
          v-if="this.$store.getters.getterResChiefChangeManagement.length == 0"
        >
          <tbody>
            <template v-if="isLoading">
              <tr>
                <td colspan="4" class="text-center">
                  <b-spinner variant="primary" label="Spinning"></b-spinner>
                </td>
              </tr>
            </template>
            <template v-else>
              <tr>
                <td colspan="4">
                  <div class="text-center">
                    <i class="flaticon2-open-box text-secondary icon-3x"></i>

                    <h4>
                      Data kosong.
                    </h4>
                  </div>
                </td>
              </tr>
            </template>
          </tbody>
        </template>
        <template v-else>
          <tbody>
            <template
              v-for="(item, i) in this.$store.getters
                .getterResChiefChangeManagement"
            >
              <tr v-bind:key="i">
                <td>{{ item.scope_category.name }}</td>
                <td>
                  <template>
                    <div v-bind:class="'response-chief-text-' + i">
                      {{ item.date }}
                    </div>
                    <div v-bind:class="'d-none response-chief-form-' + i">
                      <input
                        type="date"
                        class="form-control"
                        v-model="edit.date"
                      />
                    </div>
                  </template>
                </td>
                <td>
                  <template>
                    <div v-bind:class="'response-chief-text-' + i">
                      {{ item.status }}
                    </div>
                    <div v-bind:class="'d-none response-chief-form-' + i">
                      <b-form-select
                        class="form-control"
                        :options="chief.options"
                        v-model="edit.status"
                      ></b-form-select>
                    </div>
                  </template>
                </td>
                <td>
                  <template>
                    <div v-bind:id="'response-chief-edit-' + i">
                      <a
                        class="btn btn-light-success"
                        @click.prevent="editResponseChief(i)"
                      >
                        <i class="flaticon-edit"></i>
                      </a>
                    </div>
                    <div class="d-none" v-bind:id="'response-chief-save-' + i">
                      <a class="mr-3" @click.prevent="cancel(i)">
                        <i class="flaticon2-cross text-danger"></i>
                      </a>
                      <a
                        class="btn btn-primary"
                        @click.prevent="saveResponseChief(item, i)"
                      >
                        <template v-if="loadingUpdate">
                          <b-spinner
                            variant="light"
                            style="width: 1rem; height: 1rem;"
                            label="Spinning"
                          ></b-spinner>
                        </template>
                        <template v-else>
                          <i class="flaticon2-paperplane"></i>
                        </template>
                      </a>
                    </div>
                  </template>
                </td>
              </tr>
            </template>
          </tbody>
        </template>
      </table>
    </div>
  </div>
</template>

<script>
import {
  GET_STATUS_CHANGE,
  GET_RES_CHIEF_CHANGE_MANAGEMENT,
  UPDATE_RES_CHIEF_CHANGE_MANAGEMENT
} from "@/core/services/store/change-management.module";

export default {
  name: "ResponseChief",
  data() {
    return {
      edit: {
        date: "",
        status: ""
      },
      chief: {
        options: { text: "loading ..." }
      },
      isLoading: false,
      isEdit: false,
      loadingUpdate: false
    };
  },
  methods: {
    async editResponseChief(id) {
      if (this.isEdit == false) {
        var input = document.getElementsByClassName(
          "response-chief-form-" + id
        );
        var text = document.getElementsByClassName("response-chief-text-" + id);

        for (var i = 0; i < input.length; i++) {
          input[i].classList.remove("d-none");
          text[i].classList.add("d-none");
        }

        //button
        var edit = document.getElementById("response-chief-edit-" + id);
        var save = document.getElementById("response-chief-save-" + id);

        edit.classList.add("d-none");
        save.classList.remove("d-none");

        //get data status
        this.isEdit = true;
        this.chief.options = [];
        await this.$store.dispatch(GET_STATUS_CHANGE);

        var ops = [];
        var option = this.$store.getters.getterStatusChangeManagement;
        var select;
        for (var x = 0; x < option.length; x++) {
          select = {
            value: option[x].code,
            text: option[x].code + " - " + option[x].name
          };
          ops.push(select);
        }

        this.chief.options = ops;
      } else {
        this.$bvToast.toast("Selesaikan Edit data terlebih dahulu", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      }
    },

    cancel(id) {
      var input = document.getElementsByClassName("response-chief-form-" + id);
      var text = document.getElementsByClassName("response-chief-text-" + id);

      for (var i = 0; i < input.length; i++) {
        input[i].classList.add("d-none");
        text[i].classList.remove("d-none");
      }

      //button
      var edit = document.getElementById("response-chief-edit-" + id);
      var save = document.getElementById("response-chief-save-" + id);

      edit.classList.remove("d-none");
      save.classList.add("d-none");

      this.isEdit = false;
      this.edit.date = "";
      this.edit.status = "";
    },

    async load() {
      if (this.isEdit == false) {
        this.isLoading = true;
        await this.$store.dispatch(GET_RES_CHIEF_CHANGE_MANAGEMENT, {
          id: this.$route.params.id_change_management
        });
        this.isLoading = false;
      } else {
        this.$bvToast.toast("Selesaikan Edit data terlebih dahulu", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      }
    },

    async saveResponseChief(item, i) {
      if (this.edit.date == "" || this.edit.status == "") {
        this.$bvToast.toast("Pastikan semua form terisi", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      } else {
        var date = this.edit.date;
        var split = date.split("-");
        var fix = split[2] + "-" + split[1] + "-" + split[0];
        var send = [
          {
            id: item.id,
            date: fix,
            status: this.edit.status
          }
        ];

        this.loadingUpdate = true;
        await this.$store.dispatch(UPDATE_RES_CHIEF_CHANGE_MANAGEMENT, {
          id: this.$route.params.id_change_management,
          send: send
        });
        this.loadingUpdate = false;
        this.cancel(i);
        this.$bvToast.toast("Edit data berhasil", {
          title: "Success",
          variant: "success",
          solid: true
        });
        this.load();
        this.isEdit = false;
      }
    }
  }
};
</script>
